// PCAN Explorer Macro File
// This file can be edited and run within PCAN Explorer version 3 (Currently running version 3.2.2.374).

//This macro program sets the S300 drive to Profile Position Mode, commands target positions,
//and executes relative moves with time delays between.
//Configure the S300 drive to run motion tasks in position mode. Save to eeprom and do a Coldstart. Then run this program.


//Set up PGEARI and PGEARO
Send 601h 8 23h 93h 60h 01h 00h 00h 10h 00h // PGEARO = 20 bit
Wait 20
//Send 601h 8 40h 93h 60h 01h 00h 00h 00h 00h // 
//Wait 20

Send 601h 8 23h 93h 60h 02h 10h 27h 00h 00h // PGEARI = 10000 units
Wait 20
//Send 601h 8 40h 93h 60h 02h 00h 00h 00h 00h // 
//Wait 20

// ready to switch on	
Send 601h 8 2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on
Wait 20
//Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
//Wait 20

Send 601h 8 2bh 40h 60h 00h 07h 00h 00h 00h // Control Word: switched on
Wait 20
//Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
//Wait 20

Send 601h 8 2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: operation enable
Wait 20
Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

//***** Home Mode *****
Send 601h 8 2fh 60h 60h 00h 06h 00h 00h 00h // switch to homing mode (DS402 Mode 06)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h 8 2fh 98h 60h 00h 23h 00h 00h 00h // homing mode: set homing type - NREF=0
Wait 20
Send 601h 8 40h 98h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h 8 2bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word: start homing (Bit 4)
Wait 20
Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20

Send 601h 8 2bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word: stop homing (after finished)
Wait 20

Send 601h 8 2bh 40h 60h 00h 06h 00h 00h 00h // Control Word: ready to switch on (disable)
Wait 20


//**** Setup move ****

Send 601h 8 2Fh 60h 60h 00h 01h 00h 00h 00h // switch to profile position mode (DS402 Mode 01)
Wait 20
Send 601h 8 40h 61h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h 8 23h 83h 60h 00h 32h 00h 00h 00h // acceleration command
Wait 20
Send 601h 8 40h 83h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h 8 23h 84h 60h 00h 32h 00h 00h 00h // deceleration command
Wait 20
Send 601h 8 40h 84h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h 8 23h 81h 60h 00h 64h 00h 00h 00h // Profile Velocity setpoint (velocity command for position move) 100 rpm
Wait 20
Send 601h 8 40h 81h 60h 00h 00h 00h 00h 00h
Wait 20

//Send 601h 8 23h 94h 60h 01h 00h 00h 10h 00h // Velocity encoder factor - numerator
//Wait 20
//Send 601h 8 40h 94h 60h 01h 00h 00h 00h 00h
//Wait 20

//Send 601h 8 23h 94h 60h 02h 01h 00h 00h 00h // Velocity encoder factor - denominator
//Wait 20
//Send 601h 8 40h 94h 60h 02h 00h 00h 00h 00h
//Wait 20

Send 601h 8 2Bh 86h 60h 00h 00h 00h 00h 00h // motion profile type - Linear (trapezoidal)
Wait 20
Send 601h 8 40h 86h 60h 00h 00h 00h 00h 00h
Wait 20

Send 601h 8 2bh 40h 60h 00h 0Fh 00h 00h 00h // operation enabled, absolute move (Bit 6 = 0)
Wait 20
Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 20


JumpToHere:

Send 601h 8 23h 7Ah 60h 00h 4Ch 1Dh 00h 00h // set target position
Wait 20
//Send 601h 8 40h 7Ah 60h 00h 00h 00h 00h 00h // read target position
//Wait 20

Send 601h 8 2Bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word bit 4 ON (start new move)
Wait 200

Send 601h 8 2Bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word bit 4 OFF (reset bit 4)
Wait 20

Inposition1:
Send 601h 8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 06h 00h 00h //wait for status word bit 10 (Target Reached)
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 16h 00h 00h
			if false
				goto Inposition1
wait 1000

Send 601h 8 23h 7Ah 60h 00h 00h 00h 00h 00h // set target position
Wait 20
//Send 601h 8 40h 7Ah 60h 00h 00h 00h 00h 00h // read target position
//Wait 20

Send 601h 8 2Bh 40h 60h 00h 1Fh 00h 00h 00h // Control Word bit 4 ON (start new move)
Wait 200

Send 601h 8 2Bh 40h 60h 00h 0Fh 00h 00h 00h // Control Word bit 4 OFF (reset bit 4)
Wait 20

Inposition2:
Send 601h  8 40h 41h 60h 00h 00h 00h 00h 00h // status word
Wait 10
Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 06h 00h 00h //wait for status word bit 10 (Target Reached)
	if false
		Waitdata 12 581h 8 4Bh 41h 60h 00h 37h 16h 00h 00h
			if false
				goto Inposition2
wait 1000

GoTo JumpToHere

